<template lang="html">
  <div id="song-uploader">
    <div id="song-uploader-btn" v-if="!inputData">
      <button class="button is-link is-medium" @click="">Ajouter une chanson</button>
      <input type="file" name="resume" @change="getInputFile($event)" />
    </div>
    <div id="song-uploader-form" v-else >
      <div id="form">
        <b-field label="Donnez un nom à votre chanson">
           <b-input v-model="newSong.name" placeholder="piou font les oiseaux"></b-input>
        </b-field>
        <b-field label="Quelques mots à propos de cette chanson">
           <b-input type="textarea" v-model="newSong.description" placeholder="Cette chanson parle..."></b-input>
        </b-field>
        <b-field label="Selectionnez un type de musique qui lui convient">
           <b-select placeholder="Rock" v-model="newSong.gender">
               <option
                   v-for="gender in musicGenders"
                   :value="gender"
                   :key="gender">
                   {{ gender }}
               </option>
           </b-select>
       </b-field>
       <b-field label="Quelques tags pour relever la sauce">
         <b-taginput
             v-model="newSong.tags"
             placeholder="dance ...">
         </b-taginput>
       </b-field>
       <div class="field">
         <div class="control">
           <button class="button is-link is-medium" @click="addSong()" :disabled="!formValidity">Valider</button>
           <button class="button is-medium is-outlined" @click="flushLocalsData()">Annuler</button>
         </div>
       </div>
      </div>
    </div>
  </div>
</template>

<script>
import { getInputFile } from '@/assets/utils'
import Api from '@/api/Api'
import { mapMutations } from 'vuex'
import musicGenders from '@/assets/music-genders.json'
export default {
  name:'AudioUploader',
  props:['compositor'],
  data(){
    return{
        newSong:{
          gender:null,
          creator:this.compositor._id,
          tags:[],
          name:null,
          description:null,
          gender:null,
          artist : this.compositor.name,
          url:null,
          date:null
        },
        musicGenders : musicGenders.sort(),
        inputData:null
    }
  },
  computed:{
    newSongName() {
      return this.inputData?this.cutExtension(this.inputData.input.name,4):false
    },
    formValidity(){
      return this.newSong.name&&this.newSong.name!='';
    }
  },
  methods:{
    ...mapMutations('profile',['addNewPost']),
    getInputFile(event){
      if(getInputFile(event)){
        this.inputData = getInputFile(event);
        this.newSong.url = Date.now().toString()+'_'+this.compositor._id+'.mp3';
      }
    },
    cutExtension(str,extensionSize){
      var newStr = str.substring(0, str.length-extensionSize);
      return newStr
    },
    addSong(){
      this.newSong.date = Date.now();
      return Api.posts().post('/add_post',this.newSong).then((res) =>
        {
          this.addNewPost(this.newSong);
          this.uploadNewsong();
          this.flushLocalsData();
        }).catch((res) => {
          return res
        })
    },
    uploadNewsong(){
      const formData = new FormData();
      formData.append("uploads[]", this.inputData.input, this.newSong.url);
      return Api.posts().post('/upload_song_post',formData).then((res) =>
        {
        }).catch((res) => {
          return res
        })
    },
    flushLocalsData(){
      this.newSong = {
        gender:null,
        creator:this.compositor._id,
        tags:[],
        name:null,
        description:null,
        gender:null,
        artist : this.compositor.name,
        url:null,
        date:null
      },
      this.inputData = null;
    }
  },
  watch:{
    newSongName(val){
      this.newSong.name = val;
    }
  }
}
</script>

<style lang="scss" scoped>
#song-uploader {
  display: flex;
  align-items: center;
  justify-content: center;
  margin-bottom: 1.3rem;
  #song-uploader-btn{
    position: relative;
    display: flex;
    align-items: center;
    justify-content: center;
    button,input {
      width: 760px;
    }
    input{
      position: absolute;
      left: 0;
      top: 0;
      height: 100%;
      opacity: 0;
      cursor: pointer;
    }
  }

  #song-uploader-form {
    width: 760px;
    padding: 2rem;
    display: flex;
    flex-direction: column;
    align-items: center;
    border: 1px solid #dbdbdb;
    #form{
      width: 94%;
    }
  }

}
</style>
